/// <reference types="react" />
import type { SendMailOptions, Transporter } from "nodemailer";
import { render } from "./mjml";
export declare const EMAIL_PREFERENCES_URL = "MM_EMAIL_PREFERENCES_URL";
export declare type BuildSendMailOptions<T> = {
    transport: Transporter<T>;
    defaultFrom: string;
    configPath: string;
    processHtml?: (html: string) => string;
};
export declare type ComponentMail = SendMailOptions & {
    component?: JSX.Element;
    dangerouslyForceDeliver?: boolean;
    forcePreview?: boolean;
    previewServerUrl?: string;
    templateName?: string;
    previewName?: string;
    listName?: string;
};
export declare type Template<P> = React.FC<P> & {
    subject?: string | ((args: Partial<P>) => string);
};
export declare function getTestMailQueue(): Promise<any>;
export declare function clearTestMailQueue(): Promise<void>;
export declare function buildSendMail<T>(options: BuildSendMailOptions<T>): (mail: ComponentMail) => Promise<T | "delivered!" | undefined>;
export declare function openPreview(mail: ComponentMail, mailOptions: SendMailOptions, previewServerUrl?: string): Promise<void>;
export { buildSendMail as default, render };
