'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var open = require('open');
var fs = require('fs-extra');
var renderToMjml = require('@faire/mjml-react/utils/renderToMjml');
var mjml2html = require('mjml');
var chalk = require('chalk');
var fetch = require('node-fetch');
var posthogNode = require('posthog-node');
var nodeHtmlParser = require('node-html-parser');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var open__default = /*#__PURE__*/_interopDefault(open);
var fs__default = /*#__PURE__*/_interopDefault(fs);
var mjml2html__default = /*#__PURE__*/_interopDefault(mjml2html);
var chalk__default = /*#__PURE__*/_interopDefault(chalk);
var fetch__default = /*#__PURE__*/_interopDefault(fetch);

function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return exports;
  };
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");
        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }
        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }
          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);
          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }
          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }
      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }
      return ContinueSentinel;
    }
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct.bind();
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;
  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;
    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);
      _cache.set(Class, Wrapper);
    }
    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };
  return _wrapNativeSuper(Class);
}

function render(component, options) {
  var _options$processHtml;
  var _mjml2html = mjml2html__default["default"](renderToMjml.renderToMjml(component), {
      validationLevel: "soft"
    }),
    html = _mjml2html.html,
    errors = _mjml2html.errors;
  return {
    html: (options === null || options === void 0 ? void 0 : (_options$processHtml = options.processHtml) === null || _options$processHtml === void 0 ? void 0 : _options$processHtml.call(options, html)) || html,
    errors: errors
  };
}

var _process$env = process.env,
  DEBUG = _process$env.DEBUG,
  NODE_ENV = _process$env.NODE_ENV;
var PREFIX = "mailing";
function log(message) {
  var _console;
  for (var _len = arguments.length, optionalParams = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    optionalParams[_key - 1] = arguments[_key];
  }
  (_console = console).log.apply(_console, [chalk__default["default"].white(PREFIX), message].concat(optionalParams));
}
function error(message) {
  var _console2;
  // e.g. when there is a jest test like instrumentHtml.test.ts
  // that intentionally throws an error, don't log from a
  // try-catch that logs and re-raises the error
  if ("test" === NODE_ENV) return;
  for (var _len2 = arguments.length, optionalParams = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    optionalParams[_key2 - 1] = arguments[_key2];
  }
  (_console2 = console).error.apply(_console2, [chalk__default["default"].red(PREFIX), message].concat(optionalParams));
}
function debug(message) {
  var _console3;
  for (var _len3 = arguments.length, optionalParams = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    optionalParams[_key3 - 1] = arguments[_key3];
  }
  if (DEBUG) (_console3 = console).info.apply(_console3, [chalk__default["default"].yellowBright(PREFIX), message].concat(optionalParams));
}

var MAILING_CORE_VERSION = "1.0.0";

var POSTHOG_API_KEY = "phc_7ZFYSlHCG9Fo6a7do1BC4tUDx1DzuceaymIxZAfPUVg";
var client;
function postHogClient() {
  if (process.env.MM_E2E || process.env.CI || "test" ===         "production") return;
  if (undefined === client) {
    client = new posthogNode.PostHog(POSTHOG_API_KEY, {
      host: "https://app.posthog.com"
    });
  }
  return client;
}

// ** modified from posthog-node

function capture(_x) {
  return _capture.apply(this, arguments);
}
function _capture() {
  _capture = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(options) {
    var distinctId, captureOpts, client;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            distinctId = options.distinctId;
            captureOpts = _objectSpread2(_objectSpread2({}, options), {}, {
              distinctId: distinctId,
              properties: _objectSpread2({
                mailing_core_version: MAILING_CORE_VERSION
              }, options.properties)
            });
            debug("calling capture with ".concat(JSON.stringify(captureOpts)));
            if (!process.env.MM_DEV) {
              _context.next = 6;
              break;
            }
            debug("returning early from capture because MM_DEV is set");
            return _context.abrupt("return");
          case 6:
            _context.prev = 6;
            client = postHogClient();
            if (client) {
              _context.next = 10;
              break;
            }
            return _context.abrupt("return");
          case 10:
            {
              client.capture(captureOpts);
            }
            _context.next = 13;
            return client.shutdownAsync();
          case 13:
            _context.next = 18;
            break;
          case 15:
            _context.prev = 15;
            _context.t0 = _context["catch"](6);
            debug("posthog capture error", _context.t0);
          case 18:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[6, 15]]);
  }));
  return _capture.apply(this, arguments);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      var F = function () {};
      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var normalCompletion = true,
    didErr = false,
    err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function instrumentHtml(_ref) {
  var html = _ref.html,
    messageId = _ref.messageId,
    apiUrl = _ref.apiUrl;
  try {
    // find the a, get href, calculate new url, replace href
    var root = nodeHtmlParser.parse(html);
    var links = root.querySelectorAll("a");
    var _iterator = _createForOfIteratorHelper(links),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var link = _step.value;
        var href = link.getAttribute("href");
        if (!href) continue;
        var url = new URL("/api/hooks/click", apiUrl);
        url.searchParams.set("messageId", messageId);
        url.searchParams.set("url", href);
        link.setAttribute("href", url.toString());
      }

      // add open tracking pixel to end of body
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var body = root.querySelector("body");
    if (body) {
      var img = nodeHtmlParser.parse("<img alt=\"\" src=\"".concat(apiUrl, "/api/hooks/open?messageId=").concat(messageId, "\" />"));
      body.appendChild(img);
    } else {
      throw new Error("no body found in html");
    }
    return root.toString();
  } catch (e) {
    error("instrumentHtml error", e);
    throw e;
  }
}

var _excluded = ["component", "dangerouslyForceDeliver", "templateName", "previewName", "previewServerUrl", "forcePreview", "listName"];
var MalformedInputError = /*#__PURE__*/function (_Error) {
  _inherits(MalformedInputError, _Error);
  var _super = _createSuper(MalformedInputError);
  function MalformedInputError(message) {
    var _this;
    _classCallCheck(this, MalformedInputError);
    _this = _super.call(this, message);
    _defineProperty(_assertThisInitialized(_this), "status", void 0);
    _this.name = "MalformedInputError";
    _this.status = 422;
    return _this;
  }
  return _createClass(MalformedInputError);
}( /*#__PURE__*/_wrapNativeSuper(Error)); // In test, we write the email queue to this file so that it can be read
// by the test process.
var TMP_TEST_FILE = "tmp-testMailQueue.json";
var EMAIL_PREFERENCES_URL = "MM_EMAIL_PREFERENCES_URL";
function getTestMailQueue() {
  return _getTestMailQueue.apply(this, arguments);
}
function _getTestMailQueue() {
  _getTestMailQueue = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
    var queue;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return fs__default["default"].readFile(TMP_TEST_FILE);
          case 3:
            queue = _context2.sent;
            return _context2.abrupt("return", JSON.parse(queue.toString()));
          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2["catch"](0);
            return _context2.abrupt("return", []);
          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[0, 7]]);
  }));
  return _getTestMailQueue.apply(this, arguments);
}
function clearTestMailQueue() {
  return _clearTestMailQueue.apply(this, arguments);
}
function _clearTestMailQueue() {
  _clearTestMailQueue = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (process.env.TEST ||         "production" === "test") {
              _context3.next = 2;
              break;
            }
            throw new Error("tried to clear test mail queue not in test mode");
          case 2:
            _context3.prev = 2;
            fs__default["default"].unlinkSync(TMP_TEST_FILE);
            _context3.next = 11;
            break;
          case 6:
            _context3.prev = 6;
            _context3.t0 = _context3["catch"](2);
            if (!(_context3.t0.code === "ENOENT")) {
              _context3.next = 10;
              break;
            }
            return _context3.abrupt("return");
          case 10:
            throw _context3.t0;
          case 11:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[2, 6]]);
  }));
  return _clearTestMailQueue.apply(this, arguments);
}
function buildSendMail(options) {
  var testMode = process.env.TEST ||         "production" === "test" || process.env.MAILING_INTEGRATION_TEST;
  var integrationTestMode = !!process.env.MAILING_INTEGRATION_TEST;
  if (!(options !== null && options !== void 0 && options.transport)) {
    throw new Error("buildSendMail options are missing transport");
  }
  if (!(options !== null && options !== void 0 && options.defaultFrom)) {
    throw new Error("buildSendMail options are missing defaultFrom");
  }
  return /*#__PURE__*/function () {
    var _sendMail = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(mail) {
      var anonymousId, _process$env, NODE_ENV, MAILING_API_URL, MAILING_API_KEY, component, dangerouslyForceDeliver, templateName, previewName, previewServerUrl, forcePreview, listName, mailOptions, previewMode, analyticsEnabled, derivedTemplateName, _render, renderedHtml, errors, testMessageQueue, _mailOptions$html, emailPrefsRegex, stringHtml, htmlIncludesUnsubscribeLink, skipUnsubscribeChecks, url, hookResponse, _yield$hookResponse$j, message, memberId, _error, messageId, emailPrefsUrl, json, response;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(!mail.html && typeof mail.component === "undefined")) {
                _context.next = 2;
                break;
              }
              throw new MalformedInputError("sendMail requires either html or a component");
            case 2:
              anonymousId = "unknown";
              if (sendMail.config) {
                anonymousId = sendMail.config.anonymousId;
              }
              _process$env = process.env, NODE_ENV = _process$env.NODE_ENV, MAILING_API_URL = _process$env.MAILING_API_URL, MAILING_API_KEY = _process$env.MAILING_API_KEY;
              component = mail.component, dangerouslyForceDeliver = mail.dangerouslyForceDeliver, templateName = mail.templateName, previewName = mail.previewName, previewServerUrl = mail.previewServerUrl, forcePreview = mail.forcePreview, listName = mail.listName, mailOptions = _objectWithoutProperties(mail, _excluded);
              mailOptions.from || (mailOptions.from = options.defaultFrom);
              previewMode = forcePreview || NODE_ENV !== "production" && !dangerouslyForceDeliver;
              analyticsEnabled = !!(MAILING_API_URL && MAILING_API_KEY); // Get html from the rendered component if not provided
              if (!(component && !mailOptions.html)) {
                _context.next = 17;
                break;
              }
              _render = render(component, {
                processHtml: options.processHtml
              }), renderedHtml = _render.html, errors = _render.errors;
              if (!(errors !== null && errors !== void 0 && errors.length)) {
                _context.next = 15;
                break;
              }
              error(errors);
              throw new MalformedInputError("sendMail found errors while rendering your component: ".concat(errors.join(";")));
            case 15:
              derivedTemplateName = component.type.name;
              mailOptions.html = renderedHtml;
            case 17:
              if (mailOptions.html) {
                _context.next = 19;
                break;
              }
              throw new MalformedInputError("sendMail couldn't find your html");
            case 19:
              // Get subject from the component if not provided
              if (component && !mailOptions.subject) {
                if (typeof component.type.subject === "string") {
                  mailOptions.subject = component.type.subject;
                } else if (typeof component.type.subject === "function") {
                  mailOptions.subject = component.type.subject(component.props);
                }
              }
              if (mailOptions.subject) {
                _context.next = 22;
                break;
              }
              throw new MalformedInputError("sendMail couldn't find a subject for your email");
            case 22:
              if (!(testMode && !dangerouslyForceDeliver)) {
                _context.next = 32;
                break;
              }
              _context.next = 25;
              return getTestMailQueue();
            case 25:
              testMessageQueue = _context.sent;
              testMessageQueue.push(mailOptions);
              _context.next = 29;
              return fs__default["default"].writeFile(TMP_TEST_FILE, JSON.stringify(testMessageQueue));
            case 29:
              return _context.abrupt("return");
            case 32:
              if (!previewMode) {
                _context.next = 36;
                break;
              }
              _context.next = 35;
              return openPreview(mail, mailOptions, previewServerUrl);
            case 35:
              return _context.abrupt("return");
            case 36:
              if (!analyticsEnabled) {
                _context.next = 72;
                break;
              }
              // unsubscribe link
              emailPrefsRegex = new RegExp(EMAIL_PREFERENCES_URL, "g");
              stringHtml = (_mailOptions$html = mailOptions.html) === null || _mailOptions$html === void 0 ? void 0 : _mailOptions$html.toString();
              htmlIncludesUnsubscribeLink = emailPrefsRegex.test(stringHtml);
              if (!(listName && !htmlIncludesUnsubscribeLink)) {
                _context.next = 42;
                break;
              }
              throw new MalformedInputError("Templates sent to a list must include an unsubscribe link. Add an unsubscribe link or remove the list parameter from your sendMail call.");
            case 42:
              skipUnsubscribeChecks = !htmlIncludesUnsubscribeLink && !listName;
              url = new URL("/api/messages", MAILING_API_URL).toString();
              _context.next = 46;
              return fetch__default["default"](url, {
                method: "POST",
                headers: {
                  "Content-Type": "application/json",
                  "x-api-key": MAILING_API_KEY
                },
                body: JSON.stringify(_objectSpread2(_objectSpread2({
                  skipUnsubscribeChecks: skipUnsubscribeChecks,
                  anonymousId: anonymousId,
                  templateName: templateName || derivedTemplateName,
                  previewName: previewName
                }, mailOptions), {}, {
                  listName: listName
                }))
              });
            case 46:
              hookResponse = _context.sent;
              if (!(hookResponse.status === 200)) {
                _context.next = 61;
                break;
              }
              _context.next = 50;
              return hookResponse.json();
            case 50:
              _yield$hookResponse$j = _context.sent;
              message = _yield$hookResponse$j.message;
              memberId = _yield$hookResponse$j.memberId;
              _error = _yield$hookResponse$j.error;
              if (!_error) {
                _context.next = 57;
                break;
              }
              log("hookResponse returned error", _error);
              return _context.abrupt("return");
            case 57:
              messageId = message.id;
              if (stringHtml && memberId) {
                emailPrefsUrl = new URL("unsubscribe/".concat(memberId), MAILING_API_URL).toString();
                stringHtml = stringHtml.replace(emailPrefsRegex, emailPrefsUrl);
                mailOptions.html = instrumentHtml({
                  html: stringHtml,
                  messageId: messageId,
                  apiUrl: MAILING_API_URL
                });
              }
              _context.next = 72;
              break;
            case 61:
              _context.prev = 61;
              _context.next = 64;
              return hookResponse.json();
            case 64:
              json = _context.sent;
              _context.next = 70;
              break;
            case 67:
              _context.prev = 67;
              _context.t0 = _context["catch"](61);
              json = "could not parse response as json";
            case 70:
              error("Error calling mailing api hook", {
                status: hookResponse.status,
                statusText: hookResponse.statusText,
                json: json
              });
              return _context.abrupt("return");
            case 72:
              if (!integrationTestMode) {
                _context.next = 76;
                break;
              }
              _context.t1 = "delivered!";
              _context.next = 79;
              break;
            case 76:
              _context.next = 78;
              return options.transport.sendMail(mailOptions);
            case 78:
              _context.t1 = _context.sent;
            case 79:
              response = _context.t1;
              _context.next = 82;
              return capture({
                event: "mail sent",
                distinctId: anonymousId,
                properties: {
                  recipientCount: Array(mailOptions.to).filter(Boolean).length + Array(mailOptions.cc).filter(Boolean).length + Array(mailOptions.bcc).filter(Boolean).length,
                  analyticsEnabled: analyticsEnabled
                }
              });
            case 82:
              return _context.abrupt("return", response);
            case 83:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[61, 67]]);
    }));
    function sendMail(_x) {
      return _sendMail.apply(this, arguments);
    }
    return sendMail;
  }();
}
function openPreview(_x2, _x3, _x4) {
  return _openPreview.apply(this, arguments);
}
function _openPreview() {
  _openPreview = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(mail, mailOptions, previewServerUrl) {
    var debugMail, PREVIEW_SERVER_URL, response, _ref, id;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            debugMail = _objectSpread2(_objectSpread2({}, mail), {}, {
              html: "omitted"
            });
            log("💌 opening sendMail preview", debugMail);

            // create an intercept on the preview server
            // then open it in the browser
            PREVIEW_SERVER_URL = ("string" === typeof previewServerUrl ? previewServerUrl.trim().replace(/\/+$/, "") : "http://localhost:3883") + "/intercepts";
            _context4.prev = 3;
            _context4.next = 6;
            return fetch__default["default"](PREVIEW_SERVER_URL, {
              method: "POST",
              headers: {
                "Content-Type": "application/json"
              },
              body: JSON.stringify(mailOptions)
            });
          case 6:
            response = _context4.sent;
            if (!(response.status === 201)) {
              _context4.next = 16;
              break;
            }
            _context4.next = 10;
            return response.json();
          case 10:
            _ref = _context4.sent;
            id = _ref.id;
            _context4.next = 14;
            return open__default["default"]("".concat(PREVIEW_SERVER_URL, "/").concat(id));
          case 14:
            _context4.next = 18;
            break;
          case 16:
            error("Error hitting ".concat(PREVIEW_SERVER_URL));
            error(response);
          case 18:
            _context4.next = 24;
            break;
          case 20:
            _context4.prev = 20;
            _context4.t0 = _context4["catch"](3);
            error("Caught error 1 ".concat(_context4.t0));
            error("Is the mailing preview server running?");
          case 24:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, null, [[3, 20]]);
  }));
  return _openPreview.apply(this, arguments);
}

exports.EMAIL_PREFERENCES_URL = EMAIL_PREFERENCES_URL;
exports.buildSendMail = buildSendMail;
exports.clearTestMailQueue = clearTestMailQueue;
exports["default"] = buildSendMail;
exports.getTestMailQueue = getTestMailQueue;
exports.openPreview = openPreview;
exports.render = render;
